﻿using System;
using System.Collections.Generic;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Algorithms.IteratedSymbolicExpressionConstruction {
  [StorableClass]
  [Item("TabularMaxStateValueFunction", "")]
  public class TabularMaxStateValueFunction : TabularStateValueFunctionBase {

    public TabularMaxStateValueFunction()
      : base() {
    }

    #region item
    [StorableConstructor]
    protected TabularMaxStateValueFunction(bool deserializing) : base(deserializing) { }
    protected TabularMaxStateValueFunction(TabularMaxStateValueFunction original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new TabularMaxStateValueFunction(this, cloner);
    }
    #endregion

    protected override double CalculateNewQ(object state, double observedQuality) {
      return Math.Max(Value(state), observedQuality);
    }
  }
}
